module master_control (backdoor_in, backdoor_out, backdoor_busy, sreset_b, clk_bus_clock);

input 		sreset_b;
input		clk_bus_clock;
output [0:298]	backdoor_in;
input  [0:96]	backdoor_out;
input		backdoor_busy;
reg    [0:298]  backdoor_in;


	initial
	begin
			// Write pattern to SRAM
			backdoor_in = {1'b1, 32'hfffff020, `PPC_ATTR_8BYTE,`PPC_WRITE_WITH_FLUSH, 64'h1122334455667788, 64'h0, 64'h0, 64'h0};
			// Read from register IMMR - Let's see what's there
		@(negedge backdoor_busy)
			backdoor_in = {1'b1, 32'h000101a8, `PPC_ATTR_4BYTE,`PPC_READ, 64'h0, 64'h0, 64'h0, 64'h0};

			// Write to register BR0 - Program CS0 with 0 wait states on 60X bus at ffff_8000
		@(negedge backdoor_busy)
			backdoor_in = {1'b1, 32'h00010100, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH, 64'h00000000ffff9801, 64'h0, 64'h0, 64'h0};
			// Write to register OR0
		@(negedge backdoor_busy)
			backdoor_in = {1'b1, 32'h00010104, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH, 64'h00000000ffff8000, 64'h0, 64'h0, 64'h0};




    // Write to register BR4 - Program CS4 with 0 wait states
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0120, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_8000_0081, 64'h0, 64'h0, 64'h0};

   // Write to register OR4
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0124, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_C000_0000, 64'h0, 64'h0, 64'h0};



   // Write to register MAMR OP = 01 write (pattern for read cycles)
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0170, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_1000_0000, 64'h0, 64'h0, 64'h0};

   // Write to register RAM 1
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0188, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_3000_0000, 64'h0, 64'h0, 64'h0};

  // Transfer to UPM 
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h8000_0000, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_0000_0000, 64'h0, 64'h0, 64'h0};

   // Write to register RAM 2
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0188, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_3000_0005, 64'h0, 64'h0, 64'h0};

  // Transfer to UPM 
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h8000_0000, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_0000_0000, 64'h0, 64'h0, 64'h0};


   // Write to register MAMR OP = 10 read
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0170, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_2000_0000, 64'h0, 64'h0, 64'h0};

  // Transfer from UPM 
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h8000_0000, `PPC_ATTR_4BYTE,`PPC_READ,64'h0000_0000_0000_0000, 64'h0, 64'h0, 64'h0};

   // Read MDR
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0188, `PPC_ATTR_4BYTE,`PPC_READ,64'h0000_0000_0000_0000, 64'h0, 64'h0, 64'h0};

  // Transfer from UPM 
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h8000_0000, `PPC_ATTR_4BYTE,`PPC_READ,64'h0000_0000_0000_0000, 64'h0, 64'h0, 64'h0};

   // Read MDR
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0188, `PPC_ATTR_4BYTE,`PPC_READ,64'h0000_0000_0000_0005, 64'h0, 64'h0, 64'h0};



   // Write to register MAMR OP = 01 write (pattern for write cycles)
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0170, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_1000_0018, 64'h0, 64'h0, 64'h0};

   // Write to register RAM 1
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0188, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_1000_0000, 64'h0, 64'h0, 64'h0};

  // Transfer to UPM 
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h8000_0000, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_0000_0000, 64'h0, 64'h0, 64'h0};

   // Write to register RAM 2
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0188, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_1000_0005, 64'h0, 64'h0, 64'h0};

  // Transfer to UPM 
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h8000_0000, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_0000_0000, 64'h0, 64'h0, 64'h0};




   // Write to register MAMR OP = 00 normal
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h0001_0170, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_0000_0000, 64'h0, 64'h0, 64'h0};

  // Write pattern to FPGA
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h8000_0000, `PPC_ATTR_4BYTE,`PPC_WRITE_WITH_FLUSH,64'h0000_0000_1234_5678, 64'h0, 64'h0, 64'h0};

   // Read pattern from FPGA
  @(negedge backdoor_busy)
   backdoor_in = {1'b1, 32'h8000_0000, `PPC_ATTR_4BYTE,`PPC_READ, 64'h0,64'h0, 64'h0, 64'h0};



			// Relax
		@(negedge backdoor_busy);
			backdoor_in = 299'h0;

	end


// Monitior the bus activity

	always @(posedge backdoor_busy) 
		begin
			$display("Internal master command: addr=%x, transfer_size=%x, cycle_type=%x, \n                         data0 =%x, data1=%x, data2=%x, data3=%x\n",
			backdoor_in[1:32], backdoor_in[33:37], backdoor_in[38:42], backdoor_in[43:106], 
			backdoor_in[107:170], backdoor_in[171:234], backdoor_in[235:298]);
		end

	always @(posedge backdoor_out[0]) 
		begin
			$display(">>>>>>>>>>>>>>>>>>>>>>>>> Returned data %x from address %x\n",backdoor_out[33:96], backdoor_out[1:32]);
		end

endmodule
